/* borf.c was originally generated by the autoSql program, which also 
 * generated borf.h and borf.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "borf.h"

void borfStaticLoad(char **row, struct borf *ret)
/* Load a row from borf table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->name = row[0];
ret->size = sqlSigned(row[1]);
strcpy(ret->strand, row[2]);
ret->feature = row[3];
ret->cdsStart = sqlSigned(row[4]);
ret->cdsEnd = sqlSigned(row[5]);
ret->score = atof(row[6]);
ret->orfStart = sqlSigned(row[7]);
ret->orfEnd = sqlSigned(row[8]);
ret->cdsSize = sqlSigned(row[9]);
strcpy(ret->frame, row[10]);
ret->protein = row[11];
}

struct borf *borfLoad(char **row)
/* Load a borf from row fetched with select * from borf
 * from database.  Dispose of this with borfFree(). */
{
struct borf *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->size = sqlSigned(row[1]);
strcpy(ret->strand, row[2]);
ret->feature = cloneString(row[3]);
ret->cdsStart = sqlSigned(row[4]);
ret->cdsEnd = sqlSigned(row[5]);
ret->score = atof(row[6]);
ret->orfStart = sqlSigned(row[7]);
ret->orfEnd = sqlSigned(row[8]);
ret->cdsSize = sqlSigned(row[9]);
strcpy(ret->frame, row[10]);
ret->protein = cloneString(row[11]);
return ret;
}

struct borf *borfLoadAll(char *fileName) 
/* Load all borf from a tab-separated file.
 * Dispose of this with borfFreeList(). */
{
struct borf *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[12];

while (lineFileRow(lf, row))
    {
    el = borfLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct borf *borfLoadWhere(struct sqlConnection *conn, char *table, char *where)
/* Load all borf from table that satisfy where clause. The
 * where clause may be NULL in which case whole table is loaded
 * Dispose of this with borfFreeList(). */
{
struct borf *list = NULL, *el;
struct dyString *query = dyStringNew(256);
struct sqlResult *sr;
char **row;

dyStringPrintf(query, "select * from %s", table);
if (where != NULL)
    dyStringPrintf(query, " where %s", where);
sr = sqlGetResult(conn, query->string);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = borfLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
dyStringFree(&query);
return list;
}

struct borf *borfCommaIn(char **pS, struct borf *ret)
/* Create a borf out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new borf */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->size = sqlSignedComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
ret->feature = sqlStringComma(&s);
ret->cdsStart = sqlSignedComma(&s);
ret->cdsEnd = sqlSignedComma(&s);
ret->score = sqlFloatComma(&s);
ret->orfStart = sqlSignedComma(&s);
ret->orfEnd = sqlSignedComma(&s);
ret->cdsSize = sqlSignedComma(&s);
sqlFixedStringComma(&s, ret->frame, sizeof(ret->frame));
ret->protein = sqlStringComma(&s);
*pS = s;
return ret;
}

void borfFree(struct borf **pEl)
/* Free a single dynamically allocated borf such as created
 * with borfLoad(). */
{
struct borf *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->feature);
freeMem(el->protein);
freez(pEl);
}

void borfFreeList(struct borf **pList)
/* Free a list of dynamically allocated borf's */
{
struct borf *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    borfFree(&el);
    }
*pList = NULL;
}

void borfOutput(struct borf *el, FILE *f, char sep, char lastSep) 
/* Print out borf.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->size);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->feature);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->cdsStart);
fputc(sep,f);
fprintf(f, "%d", el->cdsEnd);
fputc(sep,f);
fprintf(f, "%f", el->score);
fputc(sep,f);
fprintf(f, "%d", el->orfStart);
fputc(sep,f);
fprintf(f, "%d", el->orfEnd);
fputc(sep,f);
fprintf(f, "%d", el->cdsSize);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->frame);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->protein);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

